/* puzzle.c generated by valac 0.46.0, the Vala compiler
 * generated from puzzle.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
enum  {
	TILE_0_PROPERTY,
	TILE_NUM_PROPERTIES
};
static GParamSpec* tile_properties[TILE_NUM_PROPERTIES];

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
typedef struct _PuzzlePrivate PuzzlePrivate;
enum  {
	PUZZLE_0_PROPERTY,
	PUZZLE_SIZE_PROPERTY,
	PUZZLE_ELAPSED_PROPERTY,
	PUZZLE_PAUSED_PROPERTY,
	PUZZLE_IS_SOLVED_PROPERTY,
	PUZZLE_CAN_MOVE_UP_PROPERTY,
	PUZZLE_CAN_MOVE_DOWN_PROPERTY,
	PUZZLE_CAN_MOVE_LEFT_PROPERTY,
	PUZZLE_CAN_MOVE_RIGHT_PROPERTY,
	PUZZLE_NUM_PROPERTIES
};
static GParamSpec* puzzle_properties[PUZZLE_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	PUZZLE_TILE_MOVED_SIGNAL,
	PUZZLE_SOLVED_SIGNAL,
	PUZZLE_PAUSED_CHANGED_SIGNAL,
	PUZZLE_TICK_SIGNAL,
	PUZZLE_NUM_SIGNALS
};
static guint puzzle_signals[PUZZLE_NUM_SIGNALS] = {0};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint north;
	gint west;
	gint east;
	gint south;
	guint x;
	guint y;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

struct _PuzzlePrivate {
	guint _size;
	Tile** board;
	gint board_length1;
	gint board_length2;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};

static gpointer tile_parent_class = NULL;
static gint Puzzle_private_offset;
static gpointer puzzle_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
Tile* tile_new (guint x,
                guint y);
Tile* tile_construct (GType object_type,
                      guint x,
                      guint y);
static void tile_finalize (GObject * obj);
GType puzzle_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
Puzzle* puzzle_new (guint size);
Puzzle* puzzle_construct (GType object_type,
                          guint size);
static void puzzle_start_clock (Puzzle* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
Tile* puzzle_get_tile (Puzzle* self,
                       guint x,
                       guint y);
void puzzle_get_tile_location (Puzzle* self,
                               Tile* tile,
                               guint* x,
                               guint* y);
guint puzzle_get_size (Puzzle* self);
gboolean puzzle_tile_fits (Puzzle* self,
                           guint x0,
                           guint y0,
                           guint x1,
                           guint y1);
gboolean puzzle_can_switch (Puzzle* self,
                            guint x0,
                            guint y0,
                            guint x1,
                            guint y1);
void puzzle_switch_tiles (Puzzle* self,
                          guint x0,
                          guint y0,
                          guint x1,
                          guint y1);
gboolean puzzle_get_is_solved (Puzzle* self);
static void puzzle_stop_clock (Puzzle* self);
void puzzle_move_up (Puzzle* self);
gboolean puzzle_get_can_move_up (Puzzle* self);
void puzzle_move_down (Puzzle* self);
gboolean puzzle_get_can_move_down (Puzzle* self);
void puzzle_move_left (Puzzle* self);
gboolean puzzle_get_can_move_left (Puzzle* self);
void puzzle_move_right (Puzzle* self);
gboolean puzzle_get_can_move_right (Puzzle* self);
void puzzle_solve (Puzzle* self);
static gboolean puzzle_timeout_cb (Puzzle* self);
static void puzzle_continue_clock (Puzzle* self);
static gboolean _puzzle_timeout_cb_gsource_func (gpointer self);
gdouble puzzle_get_elapsed (Puzzle* self);
gboolean puzzle_get_paused (Puzzle* self);
void puzzle_set_paused (Puzzle* self,
                        gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_UINT_UINT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static void puzzle_finalize (GObject * obj);
static void _vala_puzzle_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_puzzle_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

Tile*
tile_construct (GType object_type,
                guint x,
                guint y)
{
	Tile * self = NULL;
#line 24 "../src/puzzle.vala"
	self = (Tile*) g_object_new (object_type, NULL);
#line 26 "../src/puzzle.vala"
	self->x = x;
#line 27 "../src/puzzle.vala"
	self->y = y;
#line 24 "../src/puzzle.vala"
	return self;
#line 203 "puzzle.c"
}

Tile*
tile_new (guint x,
          guint y)
{
#line 24 "../src/puzzle.vala"
	return tile_construct (TYPE_TILE, x, y);
#line 212 "puzzle.c"
}

static void
tile_class_init (TileClass * klass,
                 gpointer klass_data)
{
#line 12 "../src/puzzle.vala"
	tile_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
#line 223 "puzzle.c"
}

static void
tile_instance_init (Tile * self,
                    gpointer klass)
{
}

static void
tile_finalize (GObject * obj)
{
	Tile * self;
#line 12 "../src/puzzle.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
#line 12 "../src/puzzle.vala"
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
#line 240 "puzzle.c"
}

GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
		GType tile_type_id;
		tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}

static inline gpointer
puzzle_get_instance_private (Puzzle* self)
{
	return G_STRUCT_MEMBER_P (self, Puzzle_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 136 "../src/puzzle.vala"
	return self ? g_object_ref (self) : NULL;
#line 267 "puzzle.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 98 "../src/puzzle.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 275 "puzzle.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 98 "../src/puzzle.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 283 "puzzle.c"
}

Puzzle*
puzzle_construct (GType object_type,
                  guint size)
{
	Puzzle * self = NULL;
	Tile** _tmp0_;
	GList* tiles = NULL;
#line 98 "../src/puzzle.vala"
	self = (Puzzle*) g_object_new (object_type, NULL);
#line 100 "../src/puzzle.vala"
	self->priv->_size = size;
#line 101 "../src/puzzle.vala"
	_tmp0_ = g_new0 (Tile*, ((size * 2) * size) + 1);
#line 101 "../src/puzzle.vala"
	self->priv->board = (_vala_array_free (self->priv->board, self->priv->board_length1 * self->priv->board_length2, (GDestroyNotify) g_object_unref), NULL);
#line 101 "../src/puzzle.vala"
	self->priv->board = _tmp0_;
#line 101 "../src/puzzle.vala"
	self->priv->board_length1 = size * 2;
#line 101 "../src/puzzle.vala"
	self->priv->board_length2 = size;
#line 307 "puzzle.c"
	{
		gint x = 0;
#line 102 "../src/puzzle.vala"
		x = 0;
#line 312 "puzzle.c"
		{
			gboolean _tmp1_ = FALSE;
#line 102 "../src/puzzle.vala"
			_tmp1_ = TRUE;
#line 102 "../src/puzzle.vala"
			while (TRUE) {
#line 102 "../src/puzzle.vala"
				if (!_tmp1_) {
#line 321 "puzzle.c"
					gint _tmp2_;
#line 102 "../src/puzzle.vala"
					_tmp2_ = x;
#line 102 "../src/puzzle.vala"
					x = _tmp2_ + 1;
#line 327 "puzzle.c"
				}
#line 102 "../src/puzzle.vala"
				_tmp1_ = FALSE;
#line 102 "../src/puzzle.vala"
				if (!(((guint) x) < size)) {
#line 102 "../src/puzzle.vala"
					break;
#line 335 "puzzle.c"
				}
				{
					gint y = 0;
#line 103 "../src/puzzle.vala"
					y = 0;
#line 341 "puzzle.c"
					{
						gboolean _tmp3_ = FALSE;
#line 103 "../src/puzzle.vala"
						_tmp3_ = TRUE;
#line 103 "../src/puzzle.vala"
						while (TRUE) {
#line 348 "puzzle.c"
							Tile** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Tile* _tmp6_;
#line 103 "../src/puzzle.vala"
							if (!_tmp3_) {
#line 355 "puzzle.c"
								gint _tmp4_;
#line 103 "../src/puzzle.vala"
								_tmp4_ = y;
#line 103 "../src/puzzle.vala"
								y = _tmp4_ + 1;
#line 361 "puzzle.c"
							}
#line 103 "../src/puzzle.vala"
							_tmp3_ = FALSE;
#line 103 "../src/puzzle.vala"
							if (!(((guint) y) < size)) {
#line 103 "../src/puzzle.vala"
								break;
#line 369 "puzzle.c"
							}
#line 104 "../src/puzzle.vala"
							_tmp5_ = self->priv->board;
#line 104 "../src/puzzle.vala"
							_tmp5__length1 = self->priv->board_length1;
#line 104 "../src/puzzle.vala"
							_tmp5__length2 = self->priv->board_length2;
#line 104 "../src/puzzle.vala"
							_tmp6_ = tile_new ((guint) x, (guint) y);
#line 104 "../src/puzzle.vala"
							_g_object_unref0 (_tmp5_[(x * _tmp5__length2) + y]);
#line 104 "../src/puzzle.vala"
							_tmp5_[(x * _tmp5__length2) + y] = _tmp6_;
#line 383 "puzzle.c"
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
#line 107 "../src/puzzle.vala"
		x = 0;
#line 394 "puzzle.c"
		{
			gboolean _tmp7_ = FALSE;
#line 107 "../src/puzzle.vala"
			_tmp7_ = TRUE;
#line 107 "../src/puzzle.vala"
			while (TRUE) {
#line 107 "../src/puzzle.vala"
				if (!_tmp7_) {
#line 403 "puzzle.c"
					gint _tmp8_;
#line 107 "../src/puzzle.vala"
					_tmp8_ = x;
#line 107 "../src/puzzle.vala"
					x = _tmp8_ + 1;
#line 409 "puzzle.c"
				}
#line 107 "../src/puzzle.vala"
				_tmp7_ = FALSE;
#line 107 "../src/puzzle.vala"
				if (!(((guint) x) < size)) {
#line 107 "../src/puzzle.vala"
					break;
#line 417 "puzzle.c"
				}
				{
					gint y = 0;
#line 109 "../src/puzzle.vala"
					y = 0;
#line 423 "puzzle.c"
					{
						gboolean _tmp9_ = FALSE;
#line 109 "../src/puzzle.vala"
						_tmp9_ = TRUE;
#line 109 "../src/puzzle.vala"
						while (TRUE) {
#line 430 "puzzle.c"
							gint32 n = 0;
#line 109 "../src/puzzle.vala"
							if (!_tmp9_) {
#line 434 "puzzle.c"
								gint _tmp10_;
#line 109 "../src/puzzle.vala"
								_tmp10_ = y;
#line 109 "../src/puzzle.vala"
								y = _tmp10_ + 1;
#line 440 "puzzle.c"
							}
#line 109 "../src/puzzle.vala"
							_tmp9_ = FALSE;
#line 109 "../src/puzzle.vala"
							if (!(((guint) y) <= size)) {
#line 109 "../src/puzzle.vala"
								break;
#line 448 "puzzle.c"
							}
#line 111 "../src/puzzle.vala"
							n = g_random_int_range ((gint32) 0, (gint32) 10);
#line 112 "../src/puzzle.vala"
							if ((y - 1) >= 0) {
#line 454 "puzzle.c"
								Tile** _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								Tile* _tmp12_;
#line 113 "../src/puzzle.vala"
								_tmp11_ = self->priv->board;
#line 113 "../src/puzzle.vala"
								_tmp11__length1 = self->priv->board_length1;
#line 113 "../src/puzzle.vala"
								_tmp11__length2 = self->priv->board_length2;
#line 113 "../src/puzzle.vala"
								_tmp12_ = _tmp11_[(x * _tmp11__length2) + (y - 1)];
#line 113 "../src/puzzle.vala"
								_tmp12_->south = (gint) n;
#line 469 "puzzle.c"
							}
#line 114 "../src/puzzle.vala"
							if (((guint) y) < size) {
#line 473 "puzzle.c"
								Tile** _tmp13_;
								gint _tmp13__length1;
								gint _tmp13__length2;
								Tile* _tmp14_;
#line 115 "../src/puzzle.vala"
								_tmp13_ = self->priv->board;
#line 115 "../src/puzzle.vala"
								_tmp13__length1 = self->priv->board_length1;
#line 115 "../src/puzzle.vala"
								_tmp13__length2 = self->priv->board_length2;
#line 115 "../src/puzzle.vala"
								_tmp14_ = _tmp13_[(x * _tmp13__length2) + y];
#line 115 "../src/puzzle.vala"
								_tmp14_->north = (gint) n;
#line 488 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
#line 118 "../src/puzzle.vala"
		x = 0;
#line 500 "puzzle.c"
		{
			gboolean _tmp15_ = FALSE;
#line 118 "../src/puzzle.vala"
			_tmp15_ = TRUE;
#line 118 "../src/puzzle.vala"
			while (TRUE) {
#line 118 "../src/puzzle.vala"
				if (!_tmp15_) {
#line 509 "puzzle.c"
					gint _tmp16_;
#line 118 "../src/puzzle.vala"
					_tmp16_ = x;
#line 118 "../src/puzzle.vala"
					x = _tmp16_ + 1;
#line 515 "puzzle.c"
				}
#line 118 "../src/puzzle.vala"
				_tmp15_ = FALSE;
#line 118 "../src/puzzle.vala"
				if (!(((guint) x) <= size)) {
#line 118 "../src/puzzle.vala"
					break;
#line 523 "puzzle.c"
				}
				{
					gint y = 0;
#line 120 "../src/puzzle.vala"
					y = 0;
#line 529 "puzzle.c"
					{
						gboolean _tmp17_ = FALSE;
#line 120 "../src/puzzle.vala"
						_tmp17_ = TRUE;
#line 120 "../src/puzzle.vala"
						while (TRUE) {
#line 536 "puzzle.c"
							gint32 n = 0;
#line 120 "../src/puzzle.vala"
							if (!_tmp17_) {
#line 540 "puzzle.c"
								gint _tmp18_;
#line 120 "../src/puzzle.vala"
								_tmp18_ = y;
#line 120 "../src/puzzle.vala"
								y = _tmp18_ + 1;
#line 546 "puzzle.c"
							}
#line 120 "../src/puzzle.vala"
							_tmp17_ = FALSE;
#line 120 "../src/puzzle.vala"
							if (!(((guint) y) < size)) {
#line 120 "../src/puzzle.vala"
								break;
#line 554 "puzzle.c"
							}
#line 122 "../src/puzzle.vala"
							n = g_random_int_range ((gint32) 0, (gint32) 10);
#line 123 "../src/puzzle.vala"
							if ((x - 1) >= 0) {
#line 560 "puzzle.c"
								Tile** _tmp19_;
								gint _tmp19__length1;
								gint _tmp19__length2;
								Tile* _tmp20_;
#line 124 "../src/puzzle.vala"
								_tmp19_ = self->priv->board;
#line 124 "../src/puzzle.vala"
								_tmp19__length1 = self->priv->board_length1;
#line 124 "../src/puzzle.vala"
								_tmp19__length2 = self->priv->board_length2;
#line 124 "../src/puzzle.vala"
								_tmp20_ = _tmp19_[((x - 1) * _tmp19__length2) + y];
#line 124 "../src/puzzle.vala"
								_tmp20_->east = (gint) n;
#line 575 "puzzle.c"
							}
#line 125 "../src/puzzle.vala"
							if (((guint) x) < size) {
#line 579 "puzzle.c"
								Tile** _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								Tile* _tmp22_;
#line 126 "../src/puzzle.vala"
								_tmp21_ = self->priv->board;
#line 126 "../src/puzzle.vala"
								_tmp21__length1 = self->priv->board_length1;
#line 126 "../src/puzzle.vala"
								_tmp21__length2 = self->priv->board_length2;
#line 126 "../src/puzzle.vala"
								_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
#line 126 "../src/puzzle.vala"
								_tmp22_->west = (gint) n;
#line 594 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 131 "../src/puzzle.vala"
	tiles = NULL;
#line 604 "puzzle.c"
	{
		gint x = 0;
#line 132 "../src/puzzle.vala"
		x = 0;
#line 609 "puzzle.c"
		{
			gboolean _tmp23_ = FALSE;
#line 132 "../src/puzzle.vala"
			_tmp23_ = TRUE;
#line 132 "../src/puzzle.vala"
			while (TRUE) {
#line 132 "../src/puzzle.vala"
				if (!_tmp23_) {
#line 618 "puzzle.c"
					gint _tmp24_;
#line 132 "../src/puzzle.vala"
					_tmp24_ = x;
#line 132 "../src/puzzle.vala"
					x = _tmp24_ + 1;
#line 624 "puzzle.c"
				}
#line 132 "../src/puzzle.vala"
				_tmp23_ = FALSE;
#line 132 "../src/puzzle.vala"
				if (!(((guint) x) < size)) {
#line 132 "../src/puzzle.vala"
					break;
#line 632 "puzzle.c"
				}
				{
					gint y = 0;
#line 134 "../src/puzzle.vala"
					y = 0;
#line 638 "puzzle.c"
					{
						gboolean _tmp25_ = FALSE;
#line 134 "../src/puzzle.vala"
						_tmp25_ = TRUE;
#line 134 "../src/puzzle.vala"
						while (TRUE) {
#line 645 "puzzle.c"
							Tile** _tmp27_;
							gint _tmp27__length1;
							gint _tmp27__length2;
							Tile* _tmp28_;
							Tile* _tmp29_;
							Tile** _tmp30_;
							gint _tmp30__length1;
							gint _tmp30__length2;
#line 134 "../src/puzzle.vala"
							if (!_tmp25_) {
#line 656 "puzzle.c"
								gint _tmp26_;
#line 134 "../src/puzzle.vala"
								_tmp26_ = y;
#line 134 "../src/puzzle.vala"
								y = _tmp26_ + 1;
#line 662 "puzzle.c"
							}
#line 134 "../src/puzzle.vala"
							_tmp25_ = FALSE;
#line 134 "../src/puzzle.vala"
							if (!(((guint) y) < size)) {
#line 134 "../src/puzzle.vala"
								break;
#line 670 "puzzle.c"
							}
#line 136 "../src/puzzle.vala"
							_tmp27_ = self->priv->board;
#line 136 "../src/puzzle.vala"
							_tmp27__length1 = self->priv->board_length1;
#line 136 "../src/puzzle.vala"
							_tmp27__length2 = self->priv->board_length2;
#line 136 "../src/puzzle.vala"
							_tmp28_ = _tmp27_[(x * _tmp27__length2) + y];
#line 136 "../src/puzzle.vala"
							_tmp29_ = _g_object_ref0 (_tmp28_);
#line 136 "../src/puzzle.vala"
							tiles = g_list_append (tiles, _tmp29_);
#line 137 "../src/puzzle.vala"
							_tmp30_ = self->priv->board;
#line 137 "../src/puzzle.vala"
							_tmp30__length1 = self->priv->board_length1;
#line 137 "../src/puzzle.vala"
							_tmp30__length2 = self->priv->board_length2;
#line 137 "../src/puzzle.vala"
							_g_object_unref0 (_tmp30_[(x * _tmp30__length2) + y]);
#line 137 "../src/puzzle.vala"
							_tmp30_[(x * _tmp30__length2) + y] = NULL;
#line 694 "puzzle.c"
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
#line 142 "../src/puzzle.vala"
		x = 0;
#line 705 "puzzle.c"
		{
			gboolean _tmp31_ = FALSE;
#line 142 "../src/puzzle.vala"
			_tmp31_ = TRUE;
#line 142 "../src/puzzle.vala"
			while (TRUE) {
#line 142 "../src/puzzle.vala"
				if (!_tmp31_) {
#line 714 "puzzle.c"
					gint _tmp32_;
#line 142 "../src/puzzle.vala"
					_tmp32_ = x;
#line 142 "../src/puzzle.vala"
					x = _tmp32_ + 1;
#line 720 "puzzle.c"
				}
#line 142 "../src/puzzle.vala"
				_tmp31_ = FALSE;
#line 142 "../src/puzzle.vala"
				if (!(((guint) x) < size)) {
#line 142 "../src/puzzle.vala"
					break;
#line 728 "puzzle.c"
				}
				{
					gint y = 0;
#line 144 "../src/puzzle.vala"
					y = 0;
#line 734 "puzzle.c"
					{
						gboolean _tmp33_ = FALSE;
#line 144 "../src/puzzle.vala"
						_tmp33_ = TRUE;
#line 144 "../src/puzzle.vala"
						while (TRUE) {
#line 741 "puzzle.c"
							gint32 n = 0;
							GList* _tmp35_;
							Tile* tile = NULL;
							GList* _tmp36_;
							gconstpointer _tmp37_;
							Tile* _tmp38_;
							Tile** _tmp39_;
							gint _tmp39__length1;
							gint _tmp39__length2;
							Tile* _tmp40_;
							Tile* _tmp41_;
							Tile* _tmp42_;
#line 144 "../src/puzzle.vala"
							if (!_tmp33_) {
#line 756 "puzzle.c"
								gint _tmp34_;
#line 144 "../src/puzzle.vala"
								_tmp34_ = y;
#line 144 "../src/puzzle.vala"
								y = _tmp34_ + 1;
#line 762 "puzzle.c"
							}
#line 144 "../src/puzzle.vala"
							_tmp33_ = FALSE;
#line 144 "../src/puzzle.vala"
							if (!(((guint) y) < size)) {
#line 144 "../src/puzzle.vala"
								break;
#line 770 "puzzle.c"
							}
#line 146 "../src/puzzle.vala"
							_tmp35_ = tiles;
#line 146 "../src/puzzle.vala"
							n = g_random_int_range ((gint32) 0, (gint32) g_list_length (_tmp35_));
#line 147 "../src/puzzle.vala"
							_tmp36_ = tiles;
#line 147 "../src/puzzle.vala"
							_tmp37_ = g_list_nth_data (_tmp36_, (guint) n);
#line 147 "../src/puzzle.vala"
							_tmp38_ = _g_object_ref0 ((Tile*) _tmp37_);
#line 147 "../src/puzzle.vala"
							tile = _tmp38_;
#line 148 "../src/puzzle.vala"
							_tmp39_ = self->priv->board;
#line 148 "../src/puzzle.vala"
							_tmp39__length1 = self->priv->board_length1;
#line 148 "../src/puzzle.vala"
							_tmp39__length2 = self->priv->board_length2;
#line 148 "../src/puzzle.vala"
							_tmp40_ = tile;
#line 148 "../src/puzzle.vala"
							_tmp41_ = _g_object_ref0 (_tmp40_);
#line 148 "../src/puzzle.vala"
							_g_object_unref0 (_tmp39_[((x + size) * _tmp39__length2) + y]);
#line 148 "../src/puzzle.vala"
							_tmp39_[((x + size) * _tmp39__length2) + y] = _tmp41_;
#line 149 "../src/puzzle.vala"
							_tmp42_ = tile;
#line 149 "../src/puzzle.vala"
							tiles = g_list_remove (tiles, _tmp42_);
#line 144 "../src/puzzle.vala"
							_g_object_unref0 (tile);
#line 804 "puzzle.c"
						}
					}
				}
			}
		}
	}
#line 153 "../src/puzzle.vala"
	puzzle_start_clock (self);
#line 98 "../src/puzzle.vala"
	(tiles == NULL) ? NULL : (tiles = (_g_list_free__g_object_unref0_ (tiles), NULL));
#line 98 "../src/puzzle.vala"
	return self;
#line 817 "puzzle.c"
}

Puzzle*
puzzle_new (guint size)
{
#line 98 "../src/puzzle.vala"
	return puzzle_construct (TYPE_PUZZLE, size);
#line 825 "puzzle.c"
}

Tile*
puzzle_get_tile (Puzzle* self,
                 guint x,
                 guint y)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
	Tile* result = NULL;
#line 156 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../src/puzzle.vala"
	_tmp0_ = self->priv->board;
#line 158 "../src/puzzle.vala"
	_tmp0__length1 = self->priv->board_length1;
#line 158 "../src/puzzle.vala"
	_tmp0__length2 = self->priv->board_length2;
#line 158 "../src/puzzle.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 158 "../src/puzzle.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 158 "../src/puzzle.vala"
	result = _tmp2_;
#line 158 "../src/puzzle.vala"
	return result;
#line 855 "puzzle.c"
}

void
puzzle_get_tile_location (Puzzle* self,
                          Tile* tile,
                          guint* x,
                          guint* y)
{
	guint _vala_x = 0U;
	guint _vala_y = 0U;
#line 161 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/puzzle.vala"
	g_return_if_fail (tile != NULL);
#line 163 "../src/puzzle.vala"
	_vala_y = (guint) 0;
#line 163 "../src/puzzle.vala"
	_vala_x = _vala_y;
#line 874 "puzzle.c"
	{
		gboolean _tmp0_ = FALSE;
#line 164 "../src/puzzle.vala"
		_vala_x = (guint) 0;
#line 164 "../src/puzzle.vala"
		_tmp0_ = TRUE;
#line 164 "../src/puzzle.vala"
		while (TRUE) {
#line 883 "puzzle.c"
			guint _tmp2_;
			guint _tmp3_;
#line 164 "../src/puzzle.vala"
			if (!_tmp0_) {
#line 888 "puzzle.c"
				guint _tmp1_;
#line 164 "../src/puzzle.vala"
				_tmp1_ = _vala_x;
#line 164 "../src/puzzle.vala"
				_vala_x = _tmp1_ + 1;
#line 894 "puzzle.c"
			}
#line 164 "../src/puzzle.vala"
			_tmp0_ = FALSE;
#line 164 "../src/puzzle.vala"
			_tmp2_ = puzzle_get_size (self);
#line 164 "../src/puzzle.vala"
			_tmp3_ = _tmp2_;
#line 164 "../src/puzzle.vala"
			if (!(_vala_x < (_tmp3_ * 2))) {
#line 164 "../src/puzzle.vala"
				break;
#line 906 "puzzle.c"
			}
			{
				gboolean _tmp4_ = FALSE;
#line 165 "../src/puzzle.vala"
				_vala_y = (guint) 0;
#line 165 "../src/puzzle.vala"
				_tmp4_ = TRUE;
#line 165 "../src/puzzle.vala"
				while (TRUE) {
#line 916 "puzzle.c"
					guint _tmp6_;
					guint _tmp7_;
					Tile** _tmp8_;
					gint _tmp8__length1;
					gint _tmp8__length2;
					Tile* _tmp9_;
#line 165 "../src/puzzle.vala"
					if (!_tmp4_) {
#line 925 "puzzle.c"
						guint _tmp5_;
#line 165 "../src/puzzle.vala"
						_tmp5_ = _vala_y;
#line 165 "../src/puzzle.vala"
						_vala_y = _tmp5_ + 1;
#line 931 "puzzle.c"
					}
#line 165 "../src/puzzle.vala"
					_tmp4_ = FALSE;
#line 165 "../src/puzzle.vala"
					_tmp6_ = puzzle_get_size (self);
#line 165 "../src/puzzle.vala"
					_tmp7_ = _tmp6_;
#line 165 "../src/puzzle.vala"
					if (!(_vala_y < _tmp7_)) {
#line 165 "../src/puzzle.vala"
						break;
#line 943 "puzzle.c"
					}
#line 166 "../src/puzzle.vala"
					_tmp8_ = self->priv->board;
#line 166 "../src/puzzle.vala"
					_tmp8__length1 = self->priv->board_length1;
#line 166 "../src/puzzle.vala"
					_tmp8__length2 = self->priv->board_length2;
#line 166 "../src/puzzle.vala"
					_tmp9_ = _tmp8_[(_vala_x * _tmp8__length2) + _vala_y];
#line 166 "../src/puzzle.vala"
					if (_tmp9_ == tile) {
#line 167 "../src/puzzle.vala"
						if (x) {
#line 167 "../src/puzzle.vala"
							*x = _vala_x;
#line 959 "puzzle.c"
						}
#line 167 "../src/puzzle.vala"
						if (y) {
#line 167 "../src/puzzle.vala"
							*y = _vala_y;
#line 965 "puzzle.c"
						}
#line 167 "../src/puzzle.vala"
						return;
#line 969 "puzzle.c"
					}
				}
			}
		}
	}
#line 161 "../src/puzzle.vala"
	if (x) {
#line 161 "../src/puzzle.vala"
		*x = _vala_x;
#line 979 "puzzle.c"
	}
#line 161 "../src/puzzle.vala"
	if (y) {
#line 161 "../src/puzzle.vala"
		*y = _vala_y;
#line 985 "puzzle.c"
	}
}

gboolean
puzzle_tile_fits (Puzzle* self,
                  guint x0,
                  guint y0,
                  guint x1,
                  guint y1)
{
	Tile* tile = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
	Tile* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	guint _tmp16_;
	guint _tmp17_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	guint _tmp36_;
	guint _tmp37_;
	gboolean result = FALSE;
#line 170 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "../src/puzzle.vala"
	_tmp0_ = self->priv->board;
#line 172 "../src/puzzle.vala"
	_tmp0__length1 = self->priv->board_length1;
#line 172 "../src/puzzle.vala"
	_tmp0__length2 = self->priv->board_length2;
#line 172 "../src/puzzle.vala"
	_tmp1_ = _tmp0_[(x0 * _tmp0__length2) + y0];
#line 172 "../src/puzzle.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 172 "../src/puzzle.vala"
	tile = _tmp2_;
#line 173 "../src/puzzle.vala"
	_tmp3_ = tile;
#line 173 "../src/puzzle.vala"
	if (_tmp3_ == NULL) {
#line 174 "../src/puzzle.vala"
		result = FALSE;
#line 174 "../src/puzzle.vala"
		_g_object_unref0 (tile);
#line 174 "../src/puzzle.vala"
		return result;
#line 1044 "puzzle.c"
	}
#line 176 "../src/puzzle.vala"
	if (x1 > ((guint) 0)) {
#line 1048 "puzzle.c"
		gboolean _tmp7_ = FALSE;
#line 176 "../src/puzzle.vala"
		if ((x1 - 1) == x0) {
#line 176 "../src/puzzle.vala"
			_tmp7_ = y1 == y0;
#line 1054 "puzzle.c"
		} else {
#line 176 "../src/puzzle.vala"
			_tmp7_ = FALSE;
#line 1058 "puzzle.c"
		}
#line 176 "../src/puzzle.vala"
		_tmp6_ = !_tmp7_;
#line 1062 "puzzle.c"
	} else {
#line 176 "../src/puzzle.vala"
		_tmp6_ = FALSE;
#line 1066 "puzzle.c"
	}
#line 176 "../src/puzzle.vala"
	if (_tmp6_) {
#line 1070 "puzzle.c"
		Tile** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Tile* _tmp9_;
#line 176 "../src/puzzle.vala"
		_tmp8_ = self->priv->board;
#line 176 "../src/puzzle.vala"
		_tmp8__length1 = self->priv->board_length1;
#line 176 "../src/puzzle.vala"
		_tmp8__length2 = self->priv->board_length2;
#line 176 "../src/puzzle.vala"
		_tmp9_ = _tmp8_[((x1 - 1) * _tmp8__length2) + y1];
#line 176 "../src/puzzle.vala"
		_tmp5_ = _tmp9_ != NULL;
#line 1085 "puzzle.c"
	} else {
#line 176 "../src/puzzle.vala"
		_tmp5_ = FALSE;
#line 1089 "puzzle.c"
	}
#line 176 "../src/puzzle.vala"
	if (_tmp5_) {
#line 1093 "puzzle.c"
		Tile** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Tile* _tmp11_;
		Tile* _tmp12_;
#line 176 "../src/puzzle.vala"
		_tmp10_ = self->priv->board;
#line 176 "../src/puzzle.vala"
		_tmp10__length1 = self->priv->board_length1;
#line 176 "../src/puzzle.vala"
		_tmp10__length2 = self->priv->board_length2;
#line 176 "../src/puzzle.vala"
		_tmp11_ = _tmp10_[((x1 - 1) * _tmp10__length2) + y1];
#line 176 "../src/puzzle.vala"
		_tmp12_ = tile;
#line 176 "../src/puzzle.vala"
		_tmp4_ = _tmp11_->east != _tmp12_->west;
#line 1111 "puzzle.c"
	} else {
#line 176 "../src/puzzle.vala"
		_tmp4_ = FALSE;
#line 1115 "puzzle.c"
	}
#line 176 "../src/puzzle.vala"
	if (_tmp4_) {
#line 177 "../src/puzzle.vala"
		result = FALSE;
#line 177 "../src/puzzle.vala"
		_g_object_unref0 (tile);
#line 177 "../src/puzzle.vala"
		return result;
#line 1125 "puzzle.c"
	}
#line 178 "../src/puzzle.vala"
	_tmp16_ = puzzle_get_size (self);
#line 178 "../src/puzzle.vala"
	_tmp17_ = _tmp16_;
#line 178 "../src/puzzle.vala"
	if (x1 < (_tmp17_ - 1)) {
#line 1133 "puzzle.c"
		gboolean _tmp18_ = FALSE;
#line 178 "../src/puzzle.vala"
		if ((x1 + 1) == x0) {
#line 178 "../src/puzzle.vala"
			_tmp18_ = y1 == y0;
#line 1139 "puzzle.c"
		} else {
#line 178 "../src/puzzle.vala"
			_tmp18_ = FALSE;
#line 1143 "puzzle.c"
		}
#line 178 "../src/puzzle.vala"
		_tmp15_ = !_tmp18_;
#line 1147 "puzzle.c"
	} else {
#line 178 "../src/puzzle.vala"
		_tmp15_ = FALSE;
#line 1151 "puzzle.c"
	}
#line 178 "../src/puzzle.vala"
	if (_tmp15_) {
#line 1155 "puzzle.c"
		Tile** _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		Tile* _tmp20_;
#line 178 "../src/puzzle.vala"
		_tmp19_ = self->priv->board;
#line 178 "../src/puzzle.vala"
		_tmp19__length1 = self->priv->board_length1;
#line 178 "../src/puzzle.vala"
		_tmp19__length2 = self->priv->board_length2;
#line 178 "../src/puzzle.vala"
		_tmp20_ = _tmp19_[((x1 + 1) * _tmp19__length2) + y1];
#line 178 "../src/puzzle.vala"
		_tmp14_ = _tmp20_ != NULL;
#line 1170 "puzzle.c"
	} else {
#line 178 "../src/puzzle.vala"
		_tmp14_ = FALSE;
#line 1174 "puzzle.c"
	}
#line 178 "../src/puzzle.vala"
	if (_tmp14_) {
#line 1178 "puzzle.c"
		Tile** _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		Tile* _tmp22_;
		Tile* _tmp23_;
#line 178 "../src/puzzle.vala"
		_tmp21_ = self->priv->board;
#line 178 "../src/puzzle.vala"
		_tmp21__length1 = self->priv->board_length1;
#line 178 "../src/puzzle.vala"
		_tmp21__length2 = self->priv->board_length2;
#line 178 "../src/puzzle.vala"
		_tmp22_ = _tmp21_[((x1 + 1) * _tmp21__length2) + y1];
#line 178 "../src/puzzle.vala"
		_tmp23_ = tile;
#line 178 "../src/puzzle.vala"
		_tmp13_ = _tmp22_->west != _tmp23_->east;
#line 1196 "puzzle.c"
	} else {
#line 178 "../src/puzzle.vala"
		_tmp13_ = FALSE;
#line 1200 "puzzle.c"
	}
#line 178 "../src/puzzle.vala"
	if (_tmp13_) {
#line 179 "../src/puzzle.vala"
		result = FALSE;
#line 179 "../src/puzzle.vala"
		_g_object_unref0 (tile);
#line 179 "../src/puzzle.vala"
		return result;
#line 1210 "puzzle.c"
	}
#line 180 "../src/puzzle.vala"
	if (y1 > ((guint) 0)) {
#line 1214 "puzzle.c"
		gboolean _tmp27_ = FALSE;
#line 180 "../src/puzzle.vala"
		if (x1 == x0) {
#line 180 "../src/puzzle.vala"
			_tmp27_ = (y1 - 1) == y0;
#line 1220 "puzzle.c"
		} else {
#line 180 "../src/puzzle.vala"
			_tmp27_ = FALSE;
#line 1224 "puzzle.c"
		}
#line 180 "../src/puzzle.vala"
		_tmp26_ = !_tmp27_;
#line 1228 "puzzle.c"
	} else {
#line 180 "../src/puzzle.vala"
		_tmp26_ = FALSE;
#line 1232 "puzzle.c"
	}
#line 180 "../src/puzzle.vala"
	if (_tmp26_) {
#line 1236 "puzzle.c"
		Tile** _tmp28_;
		gint _tmp28__length1;
		gint _tmp28__length2;
		Tile* _tmp29_;
#line 180 "../src/puzzle.vala"
		_tmp28_ = self->priv->board;
#line 180 "../src/puzzle.vala"
		_tmp28__length1 = self->priv->board_length1;
#line 180 "../src/puzzle.vala"
		_tmp28__length2 = self->priv->board_length2;
#line 180 "../src/puzzle.vala"
		_tmp29_ = _tmp28_[(x1 * _tmp28__length2) + (y1 - 1)];
#line 180 "../src/puzzle.vala"
		_tmp25_ = _tmp29_ != NULL;
#line 1251 "puzzle.c"
	} else {
#line 180 "../src/puzzle.vala"
		_tmp25_ = FALSE;
#line 1255 "puzzle.c"
	}
#line 180 "../src/puzzle.vala"
	if (_tmp25_) {
#line 1259 "puzzle.c"
		Tile** _tmp30_;
		gint _tmp30__length1;
		gint _tmp30__length2;
		Tile* _tmp31_;
		Tile* _tmp32_;
#line 180 "../src/puzzle.vala"
		_tmp30_ = self->priv->board;
#line 180 "../src/puzzle.vala"
		_tmp30__length1 = self->priv->board_length1;
#line 180 "../src/puzzle.vala"
		_tmp30__length2 = self->priv->board_length2;
#line 180 "../src/puzzle.vala"
		_tmp31_ = _tmp30_[(x1 * _tmp30__length2) + (y1 - 1)];
#line 180 "../src/puzzle.vala"
		_tmp32_ = tile;
#line 180 "../src/puzzle.vala"
		_tmp24_ = _tmp31_->south != _tmp32_->north;
#line 1277 "puzzle.c"
	} else {
#line 180 "../src/puzzle.vala"
		_tmp24_ = FALSE;
#line 1281 "puzzle.c"
	}
#line 180 "../src/puzzle.vala"
	if (_tmp24_) {
#line 181 "../src/puzzle.vala"
		result = FALSE;
#line 181 "../src/puzzle.vala"
		_g_object_unref0 (tile);
#line 181 "../src/puzzle.vala"
		return result;
#line 1291 "puzzle.c"
	}
#line 182 "../src/puzzle.vala"
	_tmp36_ = puzzle_get_size (self);
#line 182 "../src/puzzle.vala"
	_tmp37_ = _tmp36_;
#line 182 "../src/puzzle.vala"
	if (y1 < (_tmp37_ - 1)) {
#line 1299 "puzzle.c"
		gboolean _tmp38_ = FALSE;
#line 182 "../src/puzzle.vala"
		if (x1 == x0) {
#line 182 "../src/puzzle.vala"
			_tmp38_ = (y1 + 1) == y0;
#line 1305 "puzzle.c"
		} else {
#line 182 "../src/puzzle.vala"
			_tmp38_ = FALSE;
#line 1309 "puzzle.c"
		}
#line 182 "../src/puzzle.vala"
		_tmp35_ = !_tmp38_;
#line 1313 "puzzle.c"
	} else {
#line 182 "../src/puzzle.vala"
		_tmp35_ = FALSE;
#line 1317 "puzzle.c"
	}
#line 182 "../src/puzzle.vala"
	if (_tmp35_) {
#line 1321 "puzzle.c"
		Tile** _tmp39_;
		gint _tmp39__length1;
		gint _tmp39__length2;
		Tile* _tmp40_;
#line 182 "../src/puzzle.vala"
		_tmp39_ = self->priv->board;
#line 182 "../src/puzzle.vala"
		_tmp39__length1 = self->priv->board_length1;
#line 182 "../src/puzzle.vala"
		_tmp39__length2 = self->priv->board_length2;
#line 182 "../src/puzzle.vala"
		_tmp40_ = _tmp39_[(x1 * _tmp39__length2) + (y1 + 1)];
#line 182 "../src/puzzle.vala"
		_tmp34_ = _tmp40_ != NULL;
#line 1336 "puzzle.c"
	} else {
#line 182 "../src/puzzle.vala"
		_tmp34_ = FALSE;
#line 1340 "puzzle.c"
	}
#line 182 "../src/puzzle.vala"
	if (_tmp34_) {
#line 1344 "puzzle.c"
		Tile** _tmp41_;
		gint _tmp41__length1;
		gint _tmp41__length2;
		Tile* _tmp42_;
		Tile* _tmp43_;
#line 182 "../src/puzzle.vala"
		_tmp41_ = self->priv->board;
#line 182 "../src/puzzle.vala"
		_tmp41__length1 = self->priv->board_length1;
#line 182 "../src/puzzle.vala"
		_tmp41__length2 = self->priv->board_length2;
#line 182 "../src/puzzle.vala"
		_tmp42_ = _tmp41_[(x1 * _tmp41__length2) + (y1 + 1)];
#line 182 "../src/puzzle.vala"
		_tmp43_ = tile;
#line 182 "../src/puzzle.vala"
		_tmp33_ = _tmp42_->north != _tmp43_->south;
#line 1362 "puzzle.c"
	} else {
#line 182 "../src/puzzle.vala"
		_tmp33_ = FALSE;
#line 1366 "puzzle.c"
	}
#line 182 "../src/puzzle.vala"
	if (_tmp33_) {
#line 183 "../src/puzzle.vala"
		result = FALSE;
#line 183 "../src/puzzle.vala"
		_g_object_unref0 (tile);
#line 183 "../src/puzzle.vala"
		return result;
#line 1376 "puzzle.c"
	}
#line 185 "../src/puzzle.vala"
	result = TRUE;
#line 185 "../src/puzzle.vala"
	_g_object_unref0 (tile);
#line 185 "../src/puzzle.vala"
	return result;
#line 1384 "puzzle.c"
}

gboolean
puzzle_can_switch (Puzzle* self,
                   guint x0,
                   guint y0,
                   guint x1,
                   guint y1)
{
	gboolean _tmp0_ = FALSE;
	Tile* t0 = NULL;
	Tile** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Tile* _tmp2_;
	Tile* _tmp3_;
	Tile* t1 = NULL;
	Tile** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Tile* _tmp5_;
	Tile* _tmp6_;
	gboolean _tmp7_ = FALSE;
	Tile* _tmp8_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	Tile* _tmp12_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	Tile* _tmp17_;
	gboolean result = FALSE;
#line 188 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "../src/puzzle.vala"
	if (x0 == x1) {
#line 190 "../src/puzzle.vala"
		_tmp0_ = y0 == y1;
#line 1422 "puzzle.c"
	} else {
#line 190 "../src/puzzle.vala"
		_tmp0_ = FALSE;
#line 1426 "puzzle.c"
	}
#line 190 "../src/puzzle.vala"
	if (_tmp0_) {
#line 191 "../src/puzzle.vala"
		result = FALSE;
#line 191 "../src/puzzle.vala"
		return result;
#line 1434 "puzzle.c"
	}
#line 193 "../src/puzzle.vala"
	_tmp1_ = self->priv->board;
#line 193 "../src/puzzle.vala"
	_tmp1__length1 = self->priv->board_length1;
#line 193 "../src/puzzle.vala"
	_tmp1__length2 = self->priv->board_length2;
#line 193 "../src/puzzle.vala"
	_tmp2_ = _tmp1_[(x0 * _tmp1__length2) + y0];
#line 193 "../src/puzzle.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 193 "../src/puzzle.vala"
	t0 = _tmp3_;
#line 194 "../src/puzzle.vala"
	_tmp4_ = self->priv->board;
#line 194 "../src/puzzle.vala"
	_tmp4__length1 = self->priv->board_length1;
#line 194 "../src/puzzle.vala"
	_tmp4__length2 = self->priv->board_length2;
#line 194 "../src/puzzle.vala"
	_tmp5_ = _tmp4_[(x1 * _tmp4__length2) + y1];
#line 194 "../src/puzzle.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 194 "../src/puzzle.vala"
	t1 = _tmp6_;
#line 197 "../src/puzzle.vala"
	_tmp8_ = t0;
#line 197 "../src/puzzle.vala"
	if (_tmp8_ == NULL) {
#line 1464 "puzzle.c"
		Tile* _tmp9_;
#line 197 "../src/puzzle.vala"
		_tmp9_ = t1;
#line 197 "../src/puzzle.vala"
		_tmp7_ = _tmp9_ == NULL;
#line 1470 "puzzle.c"
	} else {
#line 197 "../src/puzzle.vala"
		_tmp7_ = FALSE;
#line 1474 "puzzle.c"
	}
#line 197 "../src/puzzle.vala"
	if (_tmp7_) {
#line 198 "../src/puzzle.vala"
		result = FALSE;
#line 198 "../src/puzzle.vala"
		_g_object_unref0 (t1);
#line 198 "../src/puzzle.vala"
		_g_object_unref0 (t0);
#line 198 "../src/puzzle.vala"
		return result;
#line 1486 "puzzle.c"
	}
#line 201 "../src/puzzle.vala"
	_tmp12_ = t0;
#line 201 "../src/puzzle.vala"
	if (_tmp12_ != NULL) {
#line 1492 "puzzle.c"
		guint _tmp13_;
		guint _tmp14_;
#line 201 "../src/puzzle.vala"
		_tmp13_ = puzzle_get_size (self);
#line 201 "../src/puzzle.vala"
		_tmp14_ = _tmp13_;
#line 201 "../src/puzzle.vala"
		_tmp11_ = x1 < _tmp14_;
#line 1501 "puzzle.c"
	} else {
#line 201 "../src/puzzle.vala"
		_tmp11_ = FALSE;
#line 1505 "puzzle.c"
	}
#line 201 "../src/puzzle.vala"
	if (_tmp11_) {
#line 201 "../src/puzzle.vala"
		_tmp10_ = !puzzle_tile_fits (self, x0, y0, x1, y1);
#line 1511 "puzzle.c"
	} else {
#line 201 "../src/puzzle.vala"
		_tmp10_ = FALSE;
#line 1515 "puzzle.c"
	}
#line 201 "../src/puzzle.vala"
	if (_tmp10_) {
#line 202 "../src/puzzle.vala"
		result = FALSE;
#line 202 "../src/puzzle.vala"
		_g_object_unref0 (t1);
#line 202 "../src/puzzle.vala"
		_g_object_unref0 (t0);
#line 202 "../src/puzzle.vala"
		return result;
#line 1527 "puzzle.c"
	}
#line 203 "../src/puzzle.vala"
	_tmp17_ = t1;
#line 203 "../src/puzzle.vala"
	if (_tmp17_ != NULL) {
#line 1533 "puzzle.c"
		guint _tmp18_;
		guint _tmp19_;
#line 203 "../src/puzzle.vala"
		_tmp18_ = puzzle_get_size (self);
#line 203 "../src/puzzle.vala"
		_tmp19_ = _tmp18_;
#line 203 "../src/puzzle.vala"
		_tmp16_ = x0 < _tmp19_;
#line 1542 "puzzle.c"
	} else {
#line 203 "../src/puzzle.vala"
		_tmp16_ = FALSE;
#line 1546 "puzzle.c"
	}
#line 203 "../src/puzzle.vala"
	if (_tmp16_) {
#line 203 "../src/puzzle.vala"
		_tmp15_ = !puzzle_tile_fits (self, x1, y1, x0, y0);
#line 1552 "puzzle.c"
	} else {
#line 203 "../src/puzzle.vala"
		_tmp15_ = FALSE;
#line 1556 "puzzle.c"
	}
#line 203 "../src/puzzle.vala"
	if (_tmp15_) {
#line 204 "../src/puzzle.vala"
		result = FALSE;
#line 204 "../src/puzzle.vala"
		_g_object_unref0 (t1);
#line 204 "../src/puzzle.vala"
		_g_object_unref0 (t0);
#line 204 "../src/puzzle.vala"
		return result;
#line 1568 "puzzle.c"
	}
#line 206 "../src/puzzle.vala"
	result = TRUE;
#line 206 "../src/puzzle.vala"
	_g_object_unref0 (t1);
#line 206 "../src/puzzle.vala"
	_g_object_unref0 (t0);
#line 206 "../src/puzzle.vala"
	return result;
#line 1578 "puzzle.c"
}

void
puzzle_switch_tiles (Puzzle* self,
                     guint x0,
                     guint y0,
                     guint x1,
                     guint y1)
{
	gboolean _tmp0_ = FALSE;
	Tile* t0 = NULL;
	Tile** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Tile* _tmp2_;
	Tile* _tmp3_;
	Tile* t1 = NULL;
	Tile** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Tile* _tmp5_;
	Tile* _tmp6_;
	Tile** _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Tile* _tmp8_;
	Tile* _tmp9_;
	Tile** _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	Tile* _tmp11_;
	Tile* _tmp12_;
	Tile* _tmp13_;
	Tile* _tmp15_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 209 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/puzzle.vala"
	if (x0 == x1) {
#line 211 "../src/puzzle.vala"
		_tmp0_ = y0 == y1;
#line 1621 "puzzle.c"
	} else {
#line 211 "../src/puzzle.vala"
		_tmp0_ = FALSE;
#line 1625 "puzzle.c"
	}
#line 211 "../src/puzzle.vala"
	if (_tmp0_) {
#line 212 "../src/puzzle.vala"
		return;
#line 1631 "puzzle.c"
	}
#line 214 "../src/puzzle.vala"
	_tmp1_ = self->priv->board;
#line 214 "../src/puzzle.vala"
	_tmp1__length1 = self->priv->board_length1;
#line 214 "../src/puzzle.vala"
	_tmp1__length2 = self->priv->board_length2;
#line 214 "../src/puzzle.vala"
	_tmp2_ = _tmp1_[(x0 * _tmp1__length2) + y0];
#line 214 "../src/puzzle.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 214 "../src/puzzle.vala"
	t0 = _tmp3_;
#line 215 "../src/puzzle.vala"
	_tmp4_ = self->priv->board;
#line 215 "../src/puzzle.vala"
	_tmp4__length1 = self->priv->board_length1;
#line 215 "../src/puzzle.vala"
	_tmp4__length2 = self->priv->board_length2;
#line 215 "../src/puzzle.vala"
	_tmp5_ = _tmp4_[(x1 * _tmp4__length2) + y1];
#line 215 "../src/puzzle.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 215 "../src/puzzle.vala"
	t1 = _tmp6_;
#line 216 "../src/puzzle.vala"
	_tmp7_ = self->priv->board;
#line 216 "../src/puzzle.vala"
	_tmp7__length1 = self->priv->board_length1;
#line 216 "../src/puzzle.vala"
	_tmp7__length2 = self->priv->board_length2;
#line 216 "../src/puzzle.vala"
	_tmp8_ = t1;
#line 216 "../src/puzzle.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 216 "../src/puzzle.vala"
	_g_object_unref0 (_tmp7_[(x0 * _tmp7__length2) + y0]);
#line 216 "../src/puzzle.vala"
	_tmp7_[(x0 * _tmp7__length2) + y0] = _tmp9_;
#line 217 "../src/puzzle.vala"
	_tmp10_ = self->priv->board;
#line 217 "../src/puzzle.vala"
	_tmp10__length1 = self->priv->board_length1;
#line 217 "../src/puzzle.vala"
	_tmp10__length2 = self->priv->board_length2;
#line 217 "../src/puzzle.vala"
	_tmp11_ = t0;
#line 217 "../src/puzzle.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 217 "../src/puzzle.vala"
	_g_object_unref0 (_tmp10_[(x1 * _tmp10__length2) + y1]);
#line 217 "../src/puzzle.vala"
	_tmp10_[(x1 * _tmp10__length2) + y1] = _tmp12_;
#line 219 "../src/puzzle.vala"
	_tmp13_ = t0;
#line 219 "../src/puzzle.vala"
	if (_tmp13_ != NULL) {
#line 1689 "puzzle.c"
		Tile* _tmp14_;
#line 220 "../src/puzzle.vala"
		_tmp14_ = t0;
#line 220 "../src/puzzle.vala"
		g_signal_emit (self, puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL], 0, _tmp14_, x1, y1);
#line 1695 "puzzle.c"
	}
#line 221 "../src/puzzle.vala"
	_tmp15_ = t1;
#line 221 "../src/puzzle.vala"
	if (_tmp15_ != NULL) {
#line 1701 "puzzle.c"
		Tile* _tmp16_;
#line 222 "../src/puzzle.vala"
		_tmp16_ = t1;
#line 222 "../src/puzzle.vala"
		g_signal_emit (self, puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL], 0, _tmp16_, x0, y0);
#line 1707 "puzzle.c"
	}
#line 224 "../src/puzzle.vala"
	_tmp17_ = puzzle_get_is_solved (self);
#line 224 "../src/puzzle.vala"
	_tmp18_ = _tmp17_;
#line 224 "../src/puzzle.vala"
	if (_tmp18_) {
#line 226 "../src/puzzle.vala"
		puzzle_stop_clock (self);
#line 227 "../src/puzzle.vala"
		g_signal_emit (self, puzzle_signals[PUZZLE_SOLVED_SIGNAL], 0);
#line 1719 "puzzle.c"
	}
#line 209 "../src/puzzle.vala"
	_g_object_unref0 (t1);
#line 209 "../src/puzzle.vala"
	_g_object_unref0 (t0);
#line 1725 "puzzle.c"
}

void
puzzle_move_up (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 242 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/puzzle.vala"
	_tmp0_ = puzzle_get_can_move_up (self);
#line 244 "../src/puzzle.vala"
	_tmp1_ = _tmp0_;
#line 244 "../src/puzzle.vala"
	if (!_tmp1_) {
#line 245 "../src/puzzle.vala"
		return;
#line 1743 "puzzle.c"
	}
	{
		gint y = 0;
#line 246 "../src/puzzle.vala"
		y = 1;
#line 1749 "puzzle.c"
		{
			gboolean _tmp2_ = FALSE;
#line 246 "../src/puzzle.vala"
			_tmp2_ = TRUE;
#line 246 "../src/puzzle.vala"
			while (TRUE) {
#line 1756 "puzzle.c"
				guint _tmp4_;
				guint _tmp5_;
#line 246 "../src/puzzle.vala"
				if (!_tmp2_) {
#line 1761 "puzzle.c"
					gint _tmp3_;
#line 246 "../src/puzzle.vala"
					_tmp3_ = y;
#line 246 "../src/puzzle.vala"
					y = _tmp3_ + 1;
#line 1767 "puzzle.c"
				}
#line 246 "../src/puzzle.vala"
				_tmp2_ = FALSE;
#line 246 "../src/puzzle.vala"
				_tmp4_ = puzzle_get_size (self);
#line 246 "../src/puzzle.vala"
				_tmp5_ = _tmp4_;
#line 246 "../src/puzzle.vala"
				if (!(((guint) y) < _tmp5_)) {
#line 246 "../src/puzzle.vala"
					break;
#line 1779 "puzzle.c"
				}
				{
					gint x = 0;
#line 247 "../src/puzzle.vala"
					x = 0;
#line 1785 "puzzle.c"
					{
						gboolean _tmp6_ = FALSE;
#line 247 "../src/puzzle.vala"
						_tmp6_ = TRUE;
#line 247 "../src/puzzle.vala"
						while (TRUE) {
#line 1792 "puzzle.c"
							guint _tmp8_;
							guint _tmp9_;
#line 247 "../src/puzzle.vala"
							if (!_tmp6_) {
#line 1797 "puzzle.c"
								gint _tmp7_;
#line 247 "../src/puzzle.vala"
								_tmp7_ = x;
#line 247 "../src/puzzle.vala"
								x = _tmp7_ + 1;
#line 1803 "puzzle.c"
							}
#line 247 "../src/puzzle.vala"
							_tmp6_ = FALSE;
#line 247 "../src/puzzle.vala"
							_tmp8_ = puzzle_get_size (self);
#line 247 "../src/puzzle.vala"
							_tmp9_ = _tmp8_;
#line 247 "../src/puzzle.vala"
							if (!(((guint) x) < _tmp9_)) {
#line 247 "../src/puzzle.vala"
								break;
#line 1815 "puzzle.c"
							}
#line 248 "../src/puzzle.vala"
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) x, (guint) (y - 1));
#line 1819 "puzzle.c"
						}
					}
				}
			}
		}
	}
}

void
puzzle_move_down (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 262 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/puzzle.vala"
	_tmp0_ = puzzle_get_can_move_down (self);
#line 264 "../src/puzzle.vala"
	_tmp1_ = _tmp0_;
#line 264 "../src/puzzle.vala"
	if (!_tmp1_) {
#line 265 "../src/puzzle.vala"
		return;
#line 1843 "puzzle.c"
	}
	{
		gint y = 0;
		guint _tmp2_;
		guint _tmp3_;
#line 266 "../src/puzzle.vala"
		_tmp2_ = puzzle_get_size (self);
#line 266 "../src/puzzle.vala"
		_tmp3_ = _tmp2_;
#line 266 "../src/puzzle.vala"
		y = ((gint) _tmp3_) - 2;
#line 1855 "puzzle.c"
		{
			gboolean _tmp4_ = FALSE;
#line 266 "../src/puzzle.vala"
			_tmp4_ = TRUE;
#line 266 "../src/puzzle.vala"
			while (TRUE) {
#line 266 "../src/puzzle.vala"
				if (!_tmp4_) {
#line 1864 "puzzle.c"
					gint _tmp5_;
#line 266 "../src/puzzle.vala"
					_tmp5_ = y;
#line 266 "../src/puzzle.vala"
					y = _tmp5_ - 1;
#line 1870 "puzzle.c"
				}
#line 266 "../src/puzzle.vala"
				_tmp4_ = FALSE;
#line 266 "../src/puzzle.vala"
				if (!(y >= 0)) {
#line 266 "../src/puzzle.vala"
					break;
#line 1878 "puzzle.c"
				}
				{
					gint x = 0;
#line 267 "../src/puzzle.vala"
					x = 0;
#line 1884 "puzzle.c"
					{
						gboolean _tmp6_ = FALSE;
#line 267 "../src/puzzle.vala"
						_tmp6_ = TRUE;
#line 267 "../src/puzzle.vala"
						while (TRUE) {
#line 1891 "puzzle.c"
							guint _tmp8_;
							guint _tmp9_;
#line 267 "../src/puzzle.vala"
							if (!_tmp6_) {
#line 1896 "puzzle.c"
								gint _tmp7_;
#line 267 "../src/puzzle.vala"
								_tmp7_ = x;
#line 267 "../src/puzzle.vala"
								x = _tmp7_ + 1;
#line 1902 "puzzle.c"
							}
#line 267 "../src/puzzle.vala"
							_tmp6_ = FALSE;
#line 267 "../src/puzzle.vala"
							_tmp8_ = puzzle_get_size (self);
#line 267 "../src/puzzle.vala"
							_tmp9_ = _tmp8_;
#line 267 "../src/puzzle.vala"
							if (!(((guint) x) < _tmp9_)) {
#line 267 "../src/puzzle.vala"
								break;
#line 1914 "puzzle.c"
							}
#line 268 "../src/puzzle.vala"
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) x, (guint) (y + 1));
#line 1918 "puzzle.c"
						}
					}
				}
			}
		}
	}
}

void
puzzle_move_left (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 282 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/puzzle.vala"
	_tmp0_ = puzzle_get_can_move_left (self);
#line 284 "../src/puzzle.vala"
	_tmp1_ = _tmp0_;
#line 284 "../src/puzzle.vala"
	if (!_tmp1_) {
#line 285 "../src/puzzle.vala"
		return;
#line 1942 "puzzle.c"
	}
	{
		gint x = 0;
#line 286 "../src/puzzle.vala"
		x = 1;
#line 1948 "puzzle.c"
		{
			gboolean _tmp2_ = FALSE;
#line 286 "../src/puzzle.vala"
			_tmp2_ = TRUE;
#line 286 "../src/puzzle.vala"
			while (TRUE) {
#line 1955 "puzzle.c"
				guint _tmp4_;
				guint _tmp5_;
#line 286 "../src/puzzle.vala"
				if (!_tmp2_) {
#line 1960 "puzzle.c"
					gint _tmp3_;
#line 286 "../src/puzzle.vala"
					_tmp3_ = x;
#line 286 "../src/puzzle.vala"
					x = _tmp3_ + 1;
#line 1966 "puzzle.c"
				}
#line 286 "../src/puzzle.vala"
				_tmp2_ = FALSE;
#line 286 "../src/puzzle.vala"
				_tmp4_ = puzzle_get_size (self);
#line 286 "../src/puzzle.vala"
				_tmp5_ = _tmp4_;
#line 286 "../src/puzzle.vala"
				if (!(((guint) x) < _tmp5_)) {
#line 286 "../src/puzzle.vala"
					break;
#line 1978 "puzzle.c"
				}
				{
					gint y = 0;
#line 287 "../src/puzzle.vala"
					y = 0;
#line 1984 "puzzle.c"
					{
						gboolean _tmp6_ = FALSE;
#line 287 "../src/puzzle.vala"
						_tmp6_ = TRUE;
#line 287 "../src/puzzle.vala"
						while (TRUE) {
#line 1991 "puzzle.c"
							guint _tmp8_;
							guint _tmp9_;
#line 287 "../src/puzzle.vala"
							if (!_tmp6_) {
#line 1996 "puzzle.c"
								gint _tmp7_;
#line 287 "../src/puzzle.vala"
								_tmp7_ = y;
#line 287 "../src/puzzle.vala"
								y = _tmp7_ + 1;
#line 2002 "puzzle.c"
							}
#line 287 "../src/puzzle.vala"
							_tmp6_ = FALSE;
#line 287 "../src/puzzle.vala"
							_tmp8_ = puzzle_get_size (self);
#line 287 "../src/puzzle.vala"
							_tmp9_ = _tmp8_;
#line 287 "../src/puzzle.vala"
							if (!(((guint) y) < _tmp9_)) {
#line 287 "../src/puzzle.vala"
								break;
#line 2014 "puzzle.c"
							}
#line 288 "../src/puzzle.vala"
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) (x - 1), (guint) y);
#line 2018 "puzzle.c"
						}
					}
				}
			}
		}
	}
}

void
puzzle_move_right (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 302 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/puzzle.vala"
	_tmp0_ = puzzle_get_can_move_right (self);
#line 304 "../src/puzzle.vala"
	_tmp1_ = _tmp0_;
#line 304 "../src/puzzle.vala"
	if (!_tmp1_) {
#line 305 "../src/puzzle.vala"
		return;
#line 2042 "puzzle.c"
	}
	{
		gint x = 0;
		guint _tmp2_;
		guint _tmp3_;
#line 306 "../src/puzzle.vala"
		_tmp2_ = puzzle_get_size (self);
#line 306 "../src/puzzle.vala"
		_tmp3_ = _tmp2_;
#line 306 "../src/puzzle.vala"
		x = ((gint) _tmp3_) - 2;
#line 2054 "puzzle.c"
		{
			gboolean _tmp4_ = FALSE;
#line 306 "../src/puzzle.vala"
			_tmp4_ = TRUE;
#line 306 "../src/puzzle.vala"
			while (TRUE) {
#line 306 "../src/puzzle.vala"
				if (!_tmp4_) {
#line 2063 "puzzle.c"
					gint _tmp5_;
#line 306 "../src/puzzle.vala"
					_tmp5_ = x;
#line 306 "../src/puzzle.vala"
					x = _tmp5_ - 1;
#line 2069 "puzzle.c"
				}
#line 306 "../src/puzzle.vala"
				_tmp4_ = FALSE;
#line 306 "../src/puzzle.vala"
				if (!(x >= 0)) {
#line 306 "../src/puzzle.vala"
					break;
#line 2077 "puzzle.c"
				}
				{
					gint y = 0;
#line 307 "../src/puzzle.vala"
					y = 0;
#line 2083 "puzzle.c"
					{
						gboolean _tmp6_ = FALSE;
#line 307 "../src/puzzle.vala"
						_tmp6_ = TRUE;
#line 307 "../src/puzzle.vala"
						while (TRUE) {
#line 2090 "puzzle.c"
							guint _tmp8_;
							guint _tmp9_;
#line 307 "../src/puzzle.vala"
							if (!_tmp6_) {
#line 2095 "puzzle.c"
								gint _tmp7_;
#line 307 "../src/puzzle.vala"
								_tmp7_ = y;
#line 307 "../src/puzzle.vala"
								y = _tmp7_ + 1;
#line 2101 "puzzle.c"
							}
#line 307 "../src/puzzle.vala"
							_tmp6_ = FALSE;
#line 307 "../src/puzzle.vala"
							_tmp8_ = puzzle_get_size (self);
#line 307 "../src/puzzle.vala"
							_tmp9_ = _tmp8_;
#line 307 "../src/puzzle.vala"
							if (!(((guint) y) < _tmp9_)) {
#line 307 "../src/puzzle.vala"
								break;
#line 2113 "puzzle.c"
							}
#line 308 "../src/puzzle.vala"
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) (x + 1), (guint) y);
#line 2117 "puzzle.c"
						}
					}
				}
			}
		}
	}
}

void
puzzle_solve (Puzzle* self)
{
	GList* wrong_tiles = NULL;
	GList* _tmp19_;
#line 311 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/puzzle.vala"
	wrong_tiles = NULL;
#line 2135 "puzzle.c"
	{
		gint x = 0;
#line 314 "../src/puzzle.vala"
		x = 0;
#line 2140 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 314 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 314 "../src/puzzle.vala"
			while (TRUE) {
#line 2147 "puzzle.c"
				guint _tmp2_;
				guint _tmp3_;
#line 314 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 2152 "puzzle.c"
					gint _tmp1_;
#line 314 "../src/puzzle.vala"
					_tmp1_ = x;
#line 314 "../src/puzzle.vala"
					x = _tmp1_ + 1;
#line 2158 "puzzle.c"
				}
#line 314 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 314 "../src/puzzle.vala"
				_tmp2_ = puzzle_get_size (self);
#line 314 "../src/puzzle.vala"
				_tmp3_ = _tmp2_;
#line 314 "../src/puzzle.vala"
				if (!(((guint) x) < (_tmp3_ * 2))) {
#line 314 "../src/puzzle.vala"
					break;
#line 2170 "puzzle.c"
				}
				{
					gint y = 0;
#line 316 "../src/puzzle.vala"
					y = 0;
#line 2176 "puzzle.c"
					{
						gboolean _tmp4_ = FALSE;
#line 316 "../src/puzzle.vala"
						_tmp4_ = TRUE;
#line 316 "../src/puzzle.vala"
						while (TRUE) {
#line 2183 "puzzle.c"
							guint _tmp6_;
							guint _tmp7_;
							Tile* tile = NULL;
							Tile** _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Tile* _tmp9_;
							Tile* _tmp10_;
							gboolean _tmp11_ = FALSE;
							Tile* _tmp12_;
							Tile** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
#line 316 "../src/puzzle.vala"
							if (!_tmp4_) {
#line 2199 "puzzle.c"
								gint _tmp5_;
#line 316 "../src/puzzle.vala"
								_tmp5_ = y;
#line 316 "../src/puzzle.vala"
								y = _tmp5_ + 1;
#line 2205 "puzzle.c"
							}
#line 316 "../src/puzzle.vala"
							_tmp4_ = FALSE;
#line 316 "../src/puzzle.vala"
							_tmp6_ = puzzle_get_size (self);
#line 316 "../src/puzzle.vala"
							_tmp7_ = _tmp6_;
#line 316 "../src/puzzle.vala"
							if (!(((guint) y) < _tmp7_)) {
#line 316 "../src/puzzle.vala"
								break;
#line 2217 "puzzle.c"
							}
#line 318 "../src/puzzle.vala"
							_tmp8_ = self->priv->board;
#line 318 "../src/puzzle.vala"
							_tmp8__length1 = self->priv->board_length1;
#line 318 "../src/puzzle.vala"
							_tmp8__length2 = self->priv->board_length2;
#line 318 "../src/puzzle.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 318 "../src/puzzle.vala"
							_tmp10_ = _g_object_ref0 (_tmp9_);
#line 318 "../src/puzzle.vala"
							tile = _tmp10_;
#line 319 "../src/puzzle.vala"
							_tmp12_ = tile;
#line 319 "../src/puzzle.vala"
							if (_tmp12_ != NULL) {
#line 2235 "puzzle.c"
								gboolean _tmp13_ = FALSE;
								Tile* _tmp14_;
#line 319 "../src/puzzle.vala"
								_tmp14_ = tile;
#line 319 "../src/puzzle.vala"
								if (_tmp14_->x != ((guint) x)) {
#line 319 "../src/puzzle.vala"
									_tmp13_ = TRUE;
#line 2244 "puzzle.c"
								} else {
									Tile* _tmp15_;
#line 319 "../src/puzzle.vala"
									_tmp15_ = tile;
#line 319 "../src/puzzle.vala"
									_tmp13_ = _tmp15_->y != ((guint) y);
#line 2251 "puzzle.c"
								}
#line 319 "../src/puzzle.vala"
								_tmp11_ = _tmp13_;
#line 2255 "puzzle.c"
							} else {
#line 319 "../src/puzzle.vala"
								_tmp11_ = FALSE;
#line 2259 "puzzle.c"
							}
#line 319 "../src/puzzle.vala"
							if (_tmp11_) {
#line 2263 "puzzle.c"
								Tile* _tmp16_;
								Tile* _tmp17_;
#line 320 "../src/puzzle.vala"
								_tmp16_ = tile;
#line 320 "../src/puzzle.vala"
								_tmp17_ = _g_object_ref0 (_tmp16_);
#line 320 "../src/puzzle.vala"
								wrong_tiles = g_list_append (wrong_tiles, _tmp17_);
#line 2272 "puzzle.c"
							}
#line 321 "../src/puzzle.vala"
							_tmp18_ = self->priv->board;
#line 321 "../src/puzzle.vala"
							_tmp18__length1 = self->priv->board_length1;
#line 321 "../src/puzzle.vala"
							_tmp18__length2 = self->priv->board_length2;
#line 321 "../src/puzzle.vala"
							_g_object_unref0 (_tmp18_[(x * _tmp18__length2) + y]);
#line 321 "../src/puzzle.vala"
							_tmp18_[(x * _tmp18__length2) + y] = NULL;
#line 316 "../src/puzzle.vala"
							_g_object_unref0 (tile);
#line 2286 "puzzle.c"
						}
					}
				}
			}
		}
	}
#line 325 "../src/puzzle.vala"
	_tmp19_ = wrong_tiles;
#line 2295 "puzzle.c"
	{
		GList* tile_collection = NULL;
		GList* tile_it = NULL;
#line 325 "../src/puzzle.vala"
		tile_collection = _tmp19_;
#line 325 "../src/puzzle.vala"
		for (tile_it = tile_collection; tile_it != NULL; tile_it = tile_it->next) {
#line 2303 "puzzle.c"
			Tile* _tmp20_;
			Tile* tile = NULL;
#line 325 "../src/puzzle.vala"
			_tmp20_ = _g_object_ref0 ((Tile*) tile_it->data);
#line 325 "../src/puzzle.vala"
			tile = _tmp20_;
#line 2310 "puzzle.c"
			{
				Tile** _tmp21_;
				gint _tmp21__length1;
				gint _tmp21__length2;
				Tile* _tmp22_;
				Tile* _tmp23_;
				Tile* _tmp24_;
				Tile* _tmp25_;
				Tile* _tmp26_;
				Tile* _tmp27_;
				Tile* _tmp28_;
#line 327 "../src/puzzle.vala"
				_tmp21_ = self->priv->board;
#line 327 "../src/puzzle.vala"
				_tmp21__length1 = self->priv->board_length1;
#line 327 "../src/puzzle.vala"
				_tmp21__length2 = self->priv->board_length2;
#line 327 "../src/puzzle.vala"
				_tmp22_ = tile;
#line 327 "../src/puzzle.vala"
				_tmp23_ = tile;
#line 327 "../src/puzzle.vala"
				_tmp24_ = tile;
#line 327 "../src/puzzle.vala"
				_tmp25_ = _g_object_ref0 (_tmp24_);
#line 327 "../src/puzzle.vala"
				_g_object_unref0 (_tmp21_[(_tmp22_->x * _tmp21__length2) + _tmp23_->y]);
#line 327 "../src/puzzle.vala"
				_tmp21_[(_tmp22_->x * _tmp21__length2) + _tmp23_->y] = _tmp25_;
#line 328 "../src/puzzle.vala"
				_tmp26_ = tile;
#line 328 "../src/puzzle.vala"
				_tmp27_ = tile;
#line 328 "../src/puzzle.vala"
				_tmp28_ = tile;
#line 328 "../src/puzzle.vala"
				g_signal_emit (self, puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL], 0, _tmp26_, _tmp27_->x, _tmp28_->y);
#line 325 "../src/puzzle.vala"
				_g_object_unref0 (tile);
#line 2350 "puzzle.c"
			}
		}
	}
#line 331 "../src/puzzle.vala"
	puzzle_stop_clock (self);
#line 311 "../src/puzzle.vala"
	(wrong_tiles == NULL) ? NULL : (wrong_tiles = (_g_list_free__g_object_unref0_ (wrong_tiles), NULL));
#line 2358 "puzzle.c"
}

static void
puzzle_start_clock (Puzzle* self)
{
	GTimer* _tmp0_;
#line 334 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/puzzle.vala"
	_tmp0_ = self->priv->clock;
#line 336 "../src/puzzle.vala"
	if (_tmp0_ == NULL) {
#line 2371 "puzzle.c"
		GTimer* _tmp1_;
#line 337 "../src/puzzle.vala"
		_tmp1_ = g_timer_new ();
#line 337 "../src/puzzle.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 337 "../src/puzzle.vala"
		self->priv->clock = _tmp1_;
#line 2379 "puzzle.c"
	}
#line 338 "../src/puzzle.vala"
	puzzle_timeout_cb (self);
#line 2383 "puzzle.c"
}

static void
puzzle_stop_clock (Puzzle* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 341 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 343 "../src/puzzle.vala"
	_tmp0_ = self->priv->clock;
#line 343 "../src/puzzle.vala"
	if (_tmp0_ == NULL) {
#line 344 "../src/puzzle.vala"
		return;
#line 2399 "puzzle.c"
	}
#line 345 "../src/puzzle.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 346 "../src/puzzle.vala"
		g_source_remove (self->priv->clock_timeout);
#line 2405 "puzzle.c"
	}
#line 347 "../src/puzzle.vala"
	self->priv->clock_timeout = (guint) 0;
#line 348 "../src/puzzle.vala"
	_tmp1_ = self->priv->clock;
#line 348 "../src/puzzle.vala"
	g_timer_stop (_tmp1_);
#line 349 "../src/puzzle.vala"
	g_signal_emit (self, puzzle_signals[PUZZLE_TICK_SIGNAL], 0);
#line 2415 "puzzle.c"
}

static void
puzzle_continue_clock (Puzzle* self)
{
	GTimer* _tmp0_;
#line 352 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 354 "../src/puzzle.vala"
	_tmp0_ = self->priv->clock;
#line 354 "../src/puzzle.vala"
	if (_tmp0_ == NULL) {
#line 2428 "puzzle.c"
		GTimer* _tmp1_;
#line 355 "../src/puzzle.vala"
		_tmp1_ = g_timer_new ();
#line 355 "../src/puzzle.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 355 "../src/puzzle.vala"
		self->priv->clock = _tmp1_;
#line 2436 "puzzle.c"
	} else {
		GTimer* _tmp2_;
#line 357 "../src/puzzle.vala"
		_tmp2_ = self->priv->clock;
#line 357 "../src/puzzle.vala"
		g_timer_continue (_tmp2_);
#line 2443 "puzzle.c"
	}
#line 358 "../src/puzzle.vala"
	puzzle_timeout_cb (self);
#line 2447 "puzzle.c"
}

static gboolean
_puzzle_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = puzzle_timeout_cb ((Puzzle*) self);
#line 367 "../src/puzzle.vala"
	return result;
#line 2457 "puzzle.c"
}

static gboolean
puzzle_timeout_cb (Puzzle* self)
{
	gdouble elapsed = 0.0;
	GTimer* _tmp0_;
	gint next = 0;
	gdouble wait = 0.0;
	gboolean result = FALSE;
#line 361 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 364 "../src/puzzle.vala"
	_tmp0_ = self->priv->clock;
#line 364 "../src/puzzle.vala"
	elapsed = g_timer_elapsed (_tmp0_, NULL);
#line 365 "../src/puzzle.vala"
	next = (gint) (elapsed + 1.0);
#line 366 "../src/puzzle.vala"
	wait = next - elapsed;
#line 367 "../src/puzzle.vala"
	self->priv->clock_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((gint) (wait * 1000)), _puzzle_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 369 "../src/puzzle.vala"
	g_signal_emit (self, puzzle_signals[PUZZLE_TICK_SIGNAL], 0);
#line 371 "../src/puzzle.vala"
	result = FALSE;
#line 371 "../src/puzzle.vala"
	return result;
#line 2486 "puzzle.c"
}

guint
puzzle_get_size (Puzzle* self)
{
	guint result;
#line 36 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 36 "../src/puzzle.vala"
	result = self->priv->_size;
#line 36 "../src/puzzle.vala"
	return result;
#line 2499 "puzzle.c"
}

gdouble
puzzle_get_elapsed (Puzzle* self)
{
	gdouble result;
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 47 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 49 "../src/puzzle.vala"
	_tmp0_ = self->priv->clock;
#line 49 "../src/puzzle.vala"
	if (_tmp0_ == NULL) {
#line 50 "../src/puzzle.vala"
		result = 0.0;
#line 50 "../src/puzzle.vala"
		return result;
#line 2518 "puzzle.c"
	}
#line 51 "../src/puzzle.vala"
	_tmp1_ = self->priv->clock;
#line 51 "../src/puzzle.vala"
	result = self->priv->clock_elapsed + g_timer_elapsed (_tmp1_, NULL);
#line 51 "../src/puzzle.vala"
	return result;
#line 2526 "puzzle.c"
}

gboolean
puzzle_get_paused (Puzzle* self)
{
	gboolean result;
#line 70 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "../src/puzzle.vala"
	result = self->priv->_paused;
#line 70 "../src/puzzle.vala"
	return result;
#line 2539 "puzzle.c"
}

void
puzzle_set_paused (Puzzle* self,
                   gboolean value)
{
	GTimer* _tmp0_;
#line 58 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/puzzle.vala"
	self->priv->_paused = value;
#line 61 "../src/puzzle.vala"
	_tmp0_ = self->priv->clock;
#line 61 "../src/puzzle.vala"
	if (_tmp0_ != NULL) {
#line 63 "../src/puzzle.vala"
		if (value) {
#line 64 "../src/puzzle.vala"
			puzzle_stop_clock (self);
#line 2559 "puzzle.c"
		} else {
#line 66 "../src/puzzle.vala"
			puzzle_continue_clock (self);
#line 2563 "puzzle.c"
		}
	}
#line 68 "../src/puzzle.vala"
	g_signal_emit (self, puzzle_signals[PUZZLE_PAUSED_CHANGED_SIGNAL], 0);
#line 58 "../src/puzzle.vala"
	g_object_notify_by_pspec ((GObject *) self, puzzle_properties[PUZZLE_PAUSED_PROPERTY]);
#line 2570 "puzzle.c"
}

gboolean
puzzle_get_is_solved (Puzzle* self)
{
	gboolean result;
#line 80 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2579 "puzzle.c"
	{
		gint x = 0;
#line 84 "../src/puzzle.vala"
		x = 0;
#line 2584 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 84 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 84 "../src/puzzle.vala"
			while (TRUE) {
#line 2591 "puzzle.c"
				guint _tmp2_;
				guint _tmp3_;
#line 84 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 2596 "puzzle.c"
					gint _tmp1_;
#line 84 "../src/puzzle.vala"
					_tmp1_ = x;
#line 84 "../src/puzzle.vala"
					x = _tmp1_ + 1;
#line 2602 "puzzle.c"
				}
#line 84 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 84 "../src/puzzle.vala"
				_tmp2_ = puzzle_get_size (self);
#line 84 "../src/puzzle.vala"
				_tmp3_ = _tmp2_;
#line 84 "../src/puzzle.vala"
				if (!(((guint) x) < _tmp3_)) {
#line 84 "../src/puzzle.vala"
					break;
#line 2614 "puzzle.c"
				}
				{
					gint y = 0;
#line 86 "../src/puzzle.vala"
					y = 0;
#line 2620 "puzzle.c"
					{
						gboolean _tmp4_ = FALSE;
#line 86 "../src/puzzle.vala"
						_tmp4_ = TRUE;
#line 86 "../src/puzzle.vala"
						while (TRUE) {
#line 2627 "puzzle.c"
							guint _tmp6_;
							guint _tmp7_;
							Tile* tile = NULL;
							Tile** _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Tile* _tmp9_;
							Tile* _tmp10_;
							Tile* _tmp11_;
#line 86 "../src/puzzle.vala"
							if (!_tmp4_) {
#line 2639 "puzzle.c"
								gint _tmp5_;
#line 86 "../src/puzzle.vala"
								_tmp5_ = y;
#line 86 "../src/puzzle.vala"
								y = _tmp5_ + 1;
#line 2645 "puzzle.c"
							}
#line 86 "../src/puzzle.vala"
							_tmp4_ = FALSE;
#line 86 "../src/puzzle.vala"
							_tmp6_ = puzzle_get_size (self);
#line 86 "../src/puzzle.vala"
							_tmp7_ = _tmp6_;
#line 86 "../src/puzzle.vala"
							if (!(((guint) y) < _tmp7_)) {
#line 86 "../src/puzzle.vala"
								break;
#line 2657 "puzzle.c"
							}
#line 88 "../src/puzzle.vala"
							_tmp8_ = self->priv->board;
#line 88 "../src/puzzle.vala"
							_tmp8__length1 = self->priv->board_length1;
#line 88 "../src/puzzle.vala"
							_tmp8__length2 = self->priv->board_length2;
#line 88 "../src/puzzle.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 88 "../src/puzzle.vala"
							_tmp10_ = _g_object_ref0 (_tmp9_);
#line 88 "../src/puzzle.vala"
							tile = _tmp10_;
#line 89 "../src/puzzle.vala"
							_tmp11_ = tile;
#line 89 "../src/puzzle.vala"
							if (_tmp11_ == NULL) {
#line 90 "../src/puzzle.vala"
								result = FALSE;
#line 90 "../src/puzzle.vala"
								_g_object_unref0 (tile);
#line 90 "../src/puzzle.vala"
								return result;
#line 2681 "puzzle.c"
							}
#line 86 "../src/puzzle.vala"
							_g_object_unref0 (tile);
#line 2685 "puzzle.c"
						}
					}
				}
			}
		}
	}
#line 94 "../src/puzzle.vala"
	result = TRUE;
#line 94 "../src/puzzle.vala"
	return result;
#line 2696 "puzzle.c"
}

gboolean
puzzle_get_can_move_up (Puzzle* self)
{
	gboolean result;
#line 233 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2705 "puzzle.c"
	{
		gint x = 0;
#line 235 "../src/puzzle.vala"
		x = 0;
#line 2710 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 235 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 235 "../src/puzzle.vala"
			while (TRUE) {
#line 2717 "puzzle.c"
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				Tile* _tmp5_;
#line 235 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 2726 "puzzle.c"
					gint _tmp1_;
#line 235 "../src/puzzle.vala"
					_tmp1_ = x;
#line 235 "../src/puzzle.vala"
					x = _tmp1_ + 1;
#line 2732 "puzzle.c"
				}
#line 235 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 235 "../src/puzzle.vala"
				_tmp2_ = puzzle_get_size (self);
#line 235 "../src/puzzle.vala"
				_tmp3_ = _tmp2_;
#line 235 "../src/puzzle.vala"
				if (!(((guint) x) < _tmp3_)) {
#line 235 "../src/puzzle.vala"
					break;
#line 2744 "puzzle.c"
				}
#line 236 "../src/puzzle.vala"
				_tmp4_ = self->priv->board;
#line 236 "../src/puzzle.vala"
				_tmp4__length1 = self->priv->board_length1;
#line 236 "../src/puzzle.vala"
				_tmp4__length2 = self->priv->board_length2;
#line 236 "../src/puzzle.vala"
				_tmp5_ = _tmp4_[(x * _tmp4__length2) + 0];
#line 236 "../src/puzzle.vala"
				if (_tmp5_ != NULL) {
#line 237 "../src/puzzle.vala"
					result = FALSE;
#line 237 "../src/puzzle.vala"
					return result;
#line 2760 "puzzle.c"
				}
			}
		}
	}
#line 238 "../src/puzzle.vala"
	result = TRUE;
#line 238 "../src/puzzle.vala"
	return result;
#line 2769 "puzzle.c"
}

gboolean
puzzle_get_can_move_down (Puzzle* self)
{
	gboolean result;
#line 253 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2778 "puzzle.c"
	{
		gint x = 0;
#line 255 "../src/puzzle.vala"
		x = 0;
#line 2783 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 255 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 255 "../src/puzzle.vala"
			while (TRUE) {
#line 2790 "puzzle.c"
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint _tmp5_;
				guint _tmp6_;
				Tile* _tmp7_;
#line 255 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 2801 "puzzle.c"
					gint _tmp1_;
#line 255 "../src/puzzle.vala"
					_tmp1_ = x;
#line 255 "../src/puzzle.vala"
					x = _tmp1_ + 1;
#line 2807 "puzzle.c"
				}
#line 255 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 255 "../src/puzzle.vala"
				_tmp2_ = puzzle_get_size (self);
#line 255 "../src/puzzle.vala"
				_tmp3_ = _tmp2_;
#line 255 "../src/puzzle.vala"
				if (!(((guint) x) < _tmp3_)) {
#line 255 "../src/puzzle.vala"
					break;
#line 2819 "puzzle.c"
				}
#line 256 "../src/puzzle.vala"
				_tmp4_ = self->priv->board;
#line 256 "../src/puzzle.vala"
				_tmp4__length1 = self->priv->board_length1;
#line 256 "../src/puzzle.vala"
				_tmp4__length2 = self->priv->board_length2;
#line 256 "../src/puzzle.vala"
				_tmp5_ = puzzle_get_size (self);
#line 256 "../src/puzzle.vala"
				_tmp6_ = _tmp5_;
#line 256 "../src/puzzle.vala"
				_tmp7_ = _tmp4_[(x * _tmp4__length2) + (_tmp6_ - 1)];
#line 256 "../src/puzzle.vala"
				if (_tmp7_ != NULL) {
#line 257 "../src/puzzle.vala"
					result = FALSE;
#line 257 "../src/puzzle.vala"
					return result;
#line 2839 "puzzle.c"
				}
			}
		}
	}
#line 258 "../src/puzzle.vala"
	result = TRUE;
#line 258 "../src/puzzle.vala"
	return result;
#line 2848 "puzzle.c"
}

gboolean
puzzle_get_can_move_left (Puzzle* self)
{
	gboolean result;
#line 273 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2857 "puzzle.c"
	{
		gint y = 0;
#line 275 "../src/puzzle.vala"
		y = 0;
#line 2862 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 275 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 275 "../src/puzzle.vala"
			while (TRUE) {
#line 2869 "puzzle.c"
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				Tile* _tmp5_;
#line 275 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 2878 "puzzle.c"
					gint _tmp1_;
#line 275 "../src/puzzle.vala"
					_tmp1_ = y;
#line 275 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 2884 "puzzle.c"
				}
#line 275 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 275 "../src/puzzle.vala"
				_tmp2_ = puzzle_get_size (self);
#line 275 "../src/puzzle.vala"
				_tmp3_ = _tmp2_;
#line 275 "../src/puzzle.vala"
				if (!(((guint) y) < _tmp3_)) {
#line 275 "../src/puzzle.vala"
					break;
#line 2896 "puzzle.c"
				}
#line 276 "../src/puzzle.vala"
				_tmp4_ = self->priv->board;
#line 276 "../src/puzzle.vala"
				_tmp4__length1 = self->priv->board_length1;
#line 276 "../src/puzzle.vala"
				_tmp4__length2 = self->priv->board_length2;
#line 276 "../src/puzzle.vala"
				_tmp5_ = _tmp4_[(0 * _tmp4__length2) + y];
#line 276 "../src/puzzle.vala"
				if (_tmp5_ != NULL) {
#line 277 "../src/puzzle.vala"
					result = FALSE;
#line 277 "../src/puzzle.vala"
					return result;
#line 2912 "puzzle.c"
				}
			}
		}
	}
#line 278 "../src/puzzle.vala"
	result = TRUE;
#line 278 "../src/puzzle.vala"
	return result;
#line 2921 "puzzle.c"
}

gboolean
puzzle_get_can_move_right (Puzzle* self)
{
	gboolean result;
#line 293 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2930 "puzzle.c"
	{
		gint y = 0;
#line 295 "../src/puzzle.vala"
		y = 0;
#line 2935 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 295 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 295 "../src/puzzle.vala"
			while (TRUE) {
#line 2942 "puzzle.c"
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint _tmp5_;
				guint _tmp6_;
				Tile* _tmp7_;
#line 295 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 2953 "puzzle.c"
					gint _tmp1_;
#line 295 "../src/puzzle.vala"
					_tmp1_ = y;
#line 295 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 2959 "puzzle.c"
				}
#line 295 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 295 "../src/puzzle.vala"
				_tmp2_ = puzzle_get_size (self);
#line 295 "../src/puzzle.vala"
				_tmp3_ = _tmp2_;
#line 295 "../src/puzzle.vala"
				if (!(((guint) y) < _tmp3_)) {
#line 295 "../src/puzzle.vala"
					break;
#line 2971 "puzzle.c"
				}
#line 296 "../src/puzzle.vala"
				_tmp4_ = self->priv->board;
#line 296 "../src/puzzle.vala"
				_tmp4__length1 = self->priv->board_length1;
#line 296 "../src/puzzle.vala"
				_tmp4__length2 = self->priv->board_length2;
#line 296 "../src/puzzle.vala"
				_tmp5_ = puzzle_get_size (self);
#line 296 "../src/puzzle.vala"
				_tmp6_ = _tmp5_;
#line 296 "../src/puzzle.vala"
				_tmp7_ = _tmp4_[((_tmp6_ - 1) * _tmp4__length2) + y];
#line 296 "../src/puzzle.vala"
				if (_tmp7_ != NULL) {
#line 297 "../src/puzzle.vala"
					result = FALSE;
#line 297 "../src/puzzle.vala"
					return result;
#line 2991 "puzzle.c"
				}
			}
		}
	}
#line 298 "../src/puzzle.vala"
	result = TRUE;
#line 298 "../src/puzzle.vala"
	return result;
#line 3000 "puzzle.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_UINT_UINT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_UINT_UINT) (gpointer data1, gpointer arg_1, guint arg_2, guint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 31 "../src/puzzle.vala"
	g_return_if_fail (n_param_values == 4);
#line 31 "../src/puzzle.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 31 "../src/puzzle.vala"
		data1 = closure->data;
#line 31 "../src/puzzle.vala"
		data2 = param_values->data[0].v_pointer;
#line 3025 "puzzle.c"
	} else {
#line 31 "../src/puzzle.vala"
		data1 = param_values->data[0].v_pointer;
#line 31 "../src/puzzle.vala"
		data2 = closure->data;
#line 3031 "puzzle.c"
	}
#line 31 "../src/puzzle.vala"
	callback = (GMarshalFunc_VOID__OBJECT_UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 31 "../src/puzzle.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_uint (param_values + 2), g_value_get_uint (param_values + 3), data2);
#line 3037 "puzzle.c"
}

static void
puzzle_class_init (PuzzleClass * klass,
                   gpointer klass_data)
{
#line 31 "../src/puzzle.vala"
	puzzle_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/puzzle.vala"
	g_type_class_adjust_private_offset (klass, &Puzzle_private_offset);
#line 31 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_get_property;
#line 31 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_set_property;
#line 31 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_finalize;
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_SIZE_PROPERTY, puzzle_properties[PUZZLE_SIZE_PROPERTY] = g_param_spec_uint ("size", "size", "size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_ELAPSED_PROPERTY, puzzle_properties[PUZZLE_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_PAUSED_PROPERTY, puzzle_properties[PUZZLE_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_IS_SOLVED_PROPERTY, puzzle_properties[PUZZLE_IS_SOLVED_PROPERTY] = g_param_spec_boolean ("is-solved", "is-solved", "is-solved", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_UP_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_UP_PROPERTY] = g_param_spec_boolean ("can-move-up", "can-move-up", "can-move-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_DOWN_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_DOWN_PROPERTY] = g_param_spec_boolean ("can-move-down", "can-move-down", "can-move-down", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_LEFT_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_LEFT_PROPERTY] = g_param_spec_boolean ("can-move-left", "can-move-left", "can-move-left", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_RIGHT_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_RIGHT_PROPERTY] = g_param_spec_boolean ("can-move-right", "can-move-right", "can-move-right", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL] = g_signal_new ("tile-moved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_UINT_UINT, G_TYPE_NONE, 3, TYPE_TILE, G_TYPE_UINT, G_TYPE_UINT);
#line 31 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_SOLVED_SIGNAL] = g_signal_new ("solved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_TICK_SIGNAL] = g_signal_new ("tick", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3078 "puzzle.c"
}

static void
puzzle_instance_init (Puzzle * self,
                      gpointer klass)
{
#line 31 "../src/puzzle.vala"
	self->priv = puzzle_get_instance_private (self);
#line 55 "../src/puzzle.vala"
	self->priv->_paused = FALSE;
#line 3089 "puzzle.c"
}

static void
puzzle_finalize (GObject * obj)
{
	Puzzle * self;
#line 31 "../src/puzzle.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE, Puzzle);
#line 38 "../src/puzzle.vala"
	self->priv->board = (_vala_array_free (self->priv->board, self->priv->board_length1 * self->priv->board_length2, (GDestroyNotify) g_object_unref), NULL);
#line 42 "../src/puzzle.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 31 "../src/puzzle.vala"
	G_OBJECT_CLASS (puzzle_parent_class)->finalize (obj);
#line 3104 "puzzle.c"
}

GType
puzzle_get_type (void)
{
	static volatile gsize puzzle_type_id__volatile = 0;
	if (g_once_init_enter (&puzzle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PuzzleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Puzzle), 0, (GInstanceInitFunc) puzzle_instance_init, NULL };
		GType puzzle_type_id;
		puzzle_type_id = g_type_register_static (G_TYPE_OBJECT, "Puzzle", &g_define_type_info, 0);
		Puzzle_private_offset = g_type_add_instance_private (puzzle_type_id, sizeof (PuzzlePrivate));
		g_once_init_leave (&puzzle_type_id__volatile, puzzle_type_id);
	}
	return puzzle_type_id__volatile;
}

static void
_vala_puzzle_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE, Puzzle);
#line 31 "../src/puzzle.vala"
	switch (property_id) {
#line 31 "../src/puzzle.vala"
		case PUZZLE_SIZE_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_uint (value, puzzle_get_size (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_ELAPSED_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_double (value, puzzle_get_elapsed (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_PAUSED_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_boolean (value, puzzle_get_paused (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_IS_SOLVED_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_boolean (value, puzzle_get_is_solved (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_CAN_MOVE_UP_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_boolean (value, puzzle_get_can_move_up (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_CAN_MOVE_DOWN_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_boolean (value, puzzle_get_can_move_down (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_CAN_MOVE_LEFT_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_boolean (value, puzzle_get_can_move_left (self));
#line 31 "../src/puzzle.vala"
		break;
#line 31 "../src/puzzle.vala"
		case PUZZLE_CAN_MOVE_RIGHT_PROPERTY:
#line 31 "../src/puzzle.vala"
		g_value_set_boolean (value, puzzle_get_can_move_right (self));
#line 31 "../src/puzzle.vala"
		break;
#line 3179 "puzzle.c"
		default:
#line 31 "../src/puzzle.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/puzzle.vala"
		break;
#line 3185 "puzzle.c"
	}
}

static void
_vala_puzzle_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE, Puzzle);
#line 31 "../src/puzzle.vala"
	switch (property_id) {
#line 31 "../src/puzzle.vala"
		case PUZZLE_PAUSED_PROPERTY:
#line 31 "../src/puzzle.vala"
		puzzle_set_paused (self, g_value_get_boolean (value));
#line 31 "../src/puzzle.vala"
		break;
#line 3205 "puzzle.c"
		default:
#line 31 "../src/puzzle.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/puzzle.vala"
		break;
#line 3211 "puzzle.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

